// DecodeWaveFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DecodeWaveFile.h"
#include "DecodeWaveFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDecodeWaveFileDlg dialog

CDecodeWaveFileDlg::CDecodeWaveFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDecodeWaveFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDecodeWaveFileDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDecodeWaveFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDecodeWaveFileDlg)
	DDX_Control(pDX, IDC_CBTTY, m_CBTTY);
	DDX_Control(pDX, IDC_CBDTMF, m_CBDTMF);
	DDX_Control(pDX, IDC_CBCUSTOMTONE, m_CBCUSTOMTONE);
	DDX_Control(pDX, IDC_CBCID, m_CBCID);
	DDX_Control(pDX, IDC_EDWAVEFN, m_EdWaveFn);
	DDX_Control(pDX, IDC_EDITLOG, m_EdLog);
	DDX_Control(pDX, IDC_PHONETONEDECODER1, m_PTDecoder);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDecodeWaveFileDlg, CDialog)
	//{{AFX_MSG_MAP(CDecodeWaveFileDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTBROWSE, OnBtbrowse)
	ON_BN_CLICKED(IDDECODE, OnDecodeIt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDecodeWaveFileDlg message handlers

BOOL CDecodeWaveFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDecodeWaveFileDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDecodeWaveFileDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDecodeWaveFileDlg::OnBtbrowse() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlgFile(TRUE,".wav",NULL,OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST,"Wave file (*.wav)|*.wav",NULL);
	if(dlgFile.DoModal() == IDOK)
	{
	 m_EdWaveFn.SetWindowText(dlgFile.GetPathName());
	} 
	
}

void CDecodeWaveFileDlg::OnDecodeIt() 
{
	// TODO: Add your control notification handler code here
	if(m_EdWaveFn.GetWindowTextLength()>0)
	{
		m_PTDecoder.SetMonitorTTY(m_CBTTY.GetCheck()==BST_CHECKED);
		m_PTDecoder.SetMonitorCallerID(m_CBCID.GetCheck()==BST_CHECKED);
		m_PTDecoder.SetMonitorDTMF(m_CBDTMF.GetCheck()==BST_CHECKED);	
		m_PTDecoder.SetMonitorCustomTone(m_CBCUSTOMTONE.GetCheck()==BST_CHECKED);
		
		CString sTemp;
		m_EdWaveFn.GetWindowText(sTemp);
		m_PTDecoder.DecodeWaveFile(sTemp);
	} else OnOnDebugPhonetonedecoder1("Please enter or browse the wave file name",0);

}

BEGIN_EVENTSINK_MAP(CDecodeWaveFileDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CDecodeWaveFileDlg)
	ON_EVENT(CDecodeWaveFileDlg, IDC_PHONETONEDECODER1, 8 /* OnDebug */, OnOnDebugPhonetonedecoder1, VTS_BSTR VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CDecodeWaveFileDlg::OnOnDebugPhonetonedecoder1(LPCTSTR sMsg, long RefCode) 
{
	// TODO: Add your control notification handler code here
	CString sTemp;
	m_EdLog.GetWindowText(sTemp);
	sTemp+=sMsg+ CString("\r\n");
	m_EdLog.SetWindowText(sTemp);
}
